<?php
##
## This adds support for wiki farms -- different sites that share a
## common code base
##
## Include from config.php, after setting up the base (default) wiki.

# Set up URLs, directories

$FieldNum = $FieldIndex[$Field];
$NextFieldNum = ($FieldNum == (count($Fields) - 1)) ? 0 : ($FieldNum + 1);
$PrevFieldNum = ($FieldNum == 0) ? (count($Fields) - 1) : ($FieldNum - 1);
$NextFieldLink = $FieldPage[$NextFieldNum];
$PrevFieldLink = $FieldPage[$PrevFieldNum];
$NextFieldName = $AsSpacedFunction($FieldName[$NextFieldNum]);
$PrevFieldName = $AsSpacedFunction($FieldName[$PrevFieldNum]);
$FarmTrail =
"&lt;- [[$PrevFieldLink $PrevFieldName]] | [[ThisFarm:/$FieldListPage Field Index]] | [[$NextFieldLink $NextFieldName]] -&gt;";

$DoubleBrackets['[[$FarmTrail]]']  = '$FarmTrail';
$DoubleBrackets['[[$Farmtrail]]']  = '$FarmTrail';

$DefaultFieldUrl = $GetFieldUrl('');
umask(0);
function mksetgiddir($dir) {
  global $ForceMkdir;
  if (is_dir($dir)) return;
  if (!$ForceMkdir) {
    $parent = dirname($dir);
    $rparent = realpath($parent);
    $perms = fileperms($parent);
    if (umask()!=0 && posix_getegid()!=filegroup($parent) && 
        ($perms & 02000)==0) 
      Abort("PmWiki wants setgid permissions enabled on <tt>$rparent</tt><br />
        before it creates the <tt>$dir</tt> directory.  <br />
        Try executing <pre>    chmod 2777 $rparent</pre> 
        on your server and reloading this page.  Afterwards, you 
        can restore the permissions<br />to their current setting by executing
        <pre>    chmod ".decoct($perms & 03777)." $rparent</pre>If this
        doesn't work for you, see the link below.","Setgid");
  }
  mkdir($dir,02777) or 
    Abort("Cannot create <tt>$dir</tt><br />
      Current directory is <tt>".getcwd()."</tt>","Mkdir");
}

mksetgiddir("wikifarm");

function GetFieldWikiDir($field) {
  if ($field == '') return "wiki.d";
  return "wikifarm/$field.wiki.d";
}
function GetFieldWikiLibDir($field) {
  if ($field == '') return "wikilib.d";
  return "wikifarm/wikilib.d";
}

SDV($FieldAfterWikiTitle,0);
if ($Field == '') {
  unset($FieldUrl);
  $FieldLinkFmt = '';
  SDV($UploadDir, "uploads");
} else {
  $DefaultPage = "$DefaultGroup/$DefaultTitle";
  if (file_exists("local/wikifarm/$Field.config.php"))
    include_once("local/wikifarm/$Field.config.php");
  $ScriptUrl = $FieldUrl = $GetFieldUrl($Field);
  $FieldLinkFmt = FmtPageName("<a href='\$PageUrl' class='title' title='$Field field home page'>".
    $AsSpacedFunction($Field).'</a>: ', $DefaultPage);
  if ($FieldAfterWikiTitle==1) $WikiTitle = "$Field - ".$WikiTitle;
  elseif ($FieldAfterWikiTitle==2) $WikiTitle = $Field;
  else $WikiTitle .= " - $Field";
  $WikiDir = GetFieldWikiDir($Field);
  #"wikifarm/$Field.wiki.d";
  $WikiLibDirs = array(&$WikiDir, GetFieldWikiLibDir($Field));
  $UploadDir = "wikifarm/$Field.uploads";
  if (isset($UploadUrlFmt))
    $UploadUrlFmt = str_replace('/uploads', "/wikifarm/$Field.uploads",
      $UploadUrlFmt);
}

SDV($UploadUrlFmt,preg_replace("#/[^/]*\$#","/$UploadDir",$FarmUrl,1));
?>